SystemOrganization addCategory: #RSSNewsReader!

Object subclass: #RSSNewsReader
	instanceVariableNames: 'list index urlList contents dropList listIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSSNewsReader'!

!RSSNewsReader class methodsFor: 'as yet unclassified' stamp: 'MJK 7/5/2013 00:37'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'News Reader')
		action: [self open];
		help: nil;
		withSeparatorAfter.! !

!RSSNewsReader class methodsFor: 'as yet unclassified' stamp: 'MJK 7/5/2013 00:35'!
open
	self new open.! !

!RSSNewsReader methodsFor: 'user-interface' stamp: 'MJK 7/4/2013 20:59'!
buildGUI
	| builder |
	
	builder := UITheme builder.
	contents := builder newColumn: {
		builder newDropListFor: self
			list: #dropList
			getSelected: #getListIndex
			setSelected: #setListIndex:
			help: nil.
		builder newListFor: self
			list: #list
			selected: #getIndex
			changeSelected: #setIndex:
			help: nil.
		builder newButtonFor: self
			action: #refresh
			label: 'Refresh'
			help: nil.
	}.! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 7/5/2013 16:51'!
dropList
	| newsSources |
	
	newsSources := OrderedCollection new.
	
	dropList do: [ :i |
		newsSources add: (i at: 2)].

	^newsSources! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 3/21/2013 08:05'!
getIndex
	^index! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 7/4/2013 21:01'!
getListIndex
	^listIndex! !

!RSSNewsReader methodsFor: 'initialization' stamp: 'MJK 7/5/2013 16:49'!
initialize
	list := OrderedCollection new.
	urlList := OrderedCollection new.
	index := 0.

	listIndex := 1.
	dropList := {
		{'http://yle.fi/uutiset/rss/uutiset.rss'. 'YLE Uutiset'}.
		{'http://store.steampowered.com/feeds/news.xml'. 'Steam News'}.
		{'http://feeds.bbci.co.uk/news/rss.xml'. 'BBC News'}.
	}.

	self buildGUI.
	self refresh.! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 3/21/2013 08:03'!
list
	^list! !

!RSSNewsReader methodsFor: 'user-interface' stamp: 'MJK 7/3/2013 22:28'!
open
	(contents openInWindowLabeled: 'News Reader') extent: 400@500.! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 7/5/2013 16:51'!
refresh
	| url source xml |
	
	url := (dropList at: listIndex) at: 1.
	
	source := url asUrl retrieveContents.
	xml := XMLDOMParser parseDocumentFrom: source.
	index := 0.
	self changed: #getIndex.
	list removeAll.
	urlList removeAll.
	self changed: #list.
	xml allElementsNamed: #item do: [ :element |
		element elementsDo: [ :element2 |
			element2 name = 'title' ifTrue: [
				list add: element2 contentString.
			].
			element2 name = 'link' ifTrue: [
				urlList add: element2 contentString.
			].
		].
	].
	self changed: #list.! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 7/4/2013 19:20'!
setIndex: anInteger
	index := anInteger.
	self changed: #getIndex.
	index = 0 ifFalse: [ Win32Shell new shellOpen: (urlList at: index) ].! !

!RSSNewsReader methodsFor: 'events' stamp: 'MJK 7/5/2013 00:25'!
setListIndex: anInteger
	listIndex := anInteger.
	listIndex = 0 ifFalse: [ self refresh ].! !
